Alto_p=660
Ancho_p=1024

set DELETE   off
SET ECHO     off
set ESCAPE   off
SET TALK     off
SET CENTURY  on
set date long
set safety   off
SET STATUS BAR Off
SET PROCEDURE TO print2pdf.prg
CLEAR
ON ERROR DO errhand WITH ;
	ERROR( ), MESSAGE( ), MESSAGE(1), PROGRAM( ), LINENO( )

if .not. file("G_INSTIT.mem")
   =MESSAGEBOX("No Existe Archivo  G_INSTIT.MEM ",16,"Marlon S.")
   quit
endif

PUBLIC fechita,it_nombre,it_anolec,it_rector,it_rec1,it_secre,it_sec1
RESTORE FROM G_INSTIT ADDITIVE

fechita = dtoc(date())
WITH _Screen
   .LockScreen=.T.
   .Closable=.F.  
   .WindowState=2
   .ScaleMode = 3
   .width=ancho_p
   .Height=alto_p
   .Picture="iconos/SoftMaS.jpg"
   .Icon="fotos\icono.ico"
   .Caption= +TRIM(it_seccion)+' '+it_anolec+' ver.29/mar/17 vfp9'
   .LockScreen=.F.
ENDWITH
fe_enc  = at(" ",fechita)
fe_lon  = len(fechita)
fechita = trim(it_ciudad)+", "+subs(fechita,fe_enc,fe_lon)
IF .not. file("G_ESTNO.dbf")
	=MESSAGEBOX("No Existe Base de Datos G_ESTNO.DBF ",16,"Marlon S.")
	QUIT
ENDIF

CLOSE DATABASES 
IF .not. file("G_ESTNO.idx")
   @10,10 say "indexando G_ESTNO.dbf"
   use G_ESTNO excl
   index on NUM_MAT to G_ESTNO
   index on curso+paral+apellid+nombres to G_ESTNO1
   @11,10 say "indexando G_ESPEC.dbf"
   use G_ESPEC excl
   index on simbolo to G_ESPEC
ENDIF

CLOSE DATABASES
@10,10 clea to 21,50

RESTORE FROM G_INSTIT ADDITIVE 
@1,1 say it_nombre FONT 'Arial', 18 STYLE "BT" COLOR "R+"
@4,1 say it_seccion FONT 'Arial', 18 STYLE "BT" COLOR "R+"
@7,1 say "Ao Lectivo :"+it_anolec FONT 'Arial', 16 STYLE "BT" COLOR "R+"
WITH _Screen
   .LockScreen=.T.
   .ScaleMode = 0
   largo = .ViewPortHeight-2
   ancho = .ViewPortWidth-2
   @largo-7,1 say "Marlon Sotomayor"
   @largo-6,1 say "Telf. Oficina: 07-2582813"
   @largo-5,1 say "WhatsApp,Claro: 099-1266443"
   @largo-4,1 say "e-mail: marlonsotomayor@gmail.com"
   @largo-3,1 say "www.marlonsotomayor.net"
   @largo-2,1 say "Av. Orillas del Zamora 03-56 y Clodoveo Carrion"
   @largo-1,1 say "Loja-Ecuador"
   .LockScreen=.F.
ENDWITH
USE g_secre SHARED
direcc1=""
DO p_check
IF direcc1<>it_direcc
   =MESSAGEBOX("Su No. de Serie incorrecto"+chr(13)+chr(13)+;
   "Comunicarce con Marlon Sotomayor"+chr(13)+CHR(13)+;
   "enviando el nombre de la Institucin"+chr(13)+CHR(13)+;
   "e-mail: marlonsotomayor@gmail.com"+chr(13)+CHR(13)+;
   "Loja - Ecuador",16,"Marlon S.")
cMessageText = 'Desea instalar el No. de Serie?'
nAnswer = MESSAGEBOX(cMessageText, 4+32+256, "Marlon S.")
   DO CASE
	CASE nAnswer = 6
n_ser1="123"
n_ser2="123"
n_ser3="123"
n_ser4="123"
n_ser5="123"
n_ser6="123"
n_ser7="123"
n_ser8="123"
n_ser9="123"
n_ser10="123"
n_ser11="123"
n_ser12="123"
	 	 do form f_serie
   ENDCASE
   quit
endif
cla_aux = "          "
ini_aux = "...."
do form f_clave
use g_secre share
if inicial="MFSB".and.nombre="Marlon Sotomayor".and.clave="SotomayorB"
	locate for cla_aux=clave
	if eof()
		=MESSAGEBOX("No existe clave"+chr(13)+chr(13)+;
		"Comunicarce con Marlon S."+chr(13)+CHR(13)+;
		"e-mail: marlonsotomayor@gmail.com"+chr(13)+CHR(13)+;
		"Loja - Ecuador",16,"Marlon S.")
		QUIT
	endif
else
   =MESSAGEBOX("No existe clave"+chr(13)+chr(13)+;
   "Comunicarce con Marlon Sotomayor"+chr(13)+CHR(13)+;
   "e-mail: marlonsotomayor@gmail.com"+chr(13)+CHR(13)+;
   "Loja - Ecuador",16,"Marlon S.")
   quit
endif
clave_gen=.f.
clave_tip=tipo
if tipo<>'C'.and.tipo<>'A'
   =MESSAGEBOX("Lo sentimos pero"+chr(13)+chr(13)+;
   "Este modulo es solo para Colecturia"+chr(13)+CHR(13)+;
   "gracias ... ",16,"Marlon S.")
   quit
endif
if gen
   clave_gen=.t.
endif

nom_secre=nombre
if nombre="Marlon Sotomayor"
   @11,1 say "Usuario : Administrador" FONT 'Arial', 10 STYLE "BT" COLOR "B+"
else
   @11,1 say "Usuario :"+nombre FONT 'Arial', 10 STYLE "BT" COLOR "B+"
endif
@12,1 say fechita FONT 'Arial', 10 STYLE "BT" COLOR "B+"
USE

* definicion de pantalla para imprimir
DEFINE WINDOW modi_repo FROM 0,0 TO largo,ancho TITLE 'Moficar Reporte (Marlon S.)';
   SYSTEM CLOSE FLOAT GROW ZOOM
DEFINE WINDOW ver_repo FROM 0,0 TO largo,ancho TITLE 'Reporte en Pantalla (Marlon S.)';
   SYSTEM CLOSE FLOAT GROW ZOOM

hoy_fec= date()
hoy_hor= time()
*save all like hoy_??? to &ini_aux
*************
*** Respaldar
anio = str(year(date()),4)
mes  = mont(date())
dia  = str(day(date()),2)
IF mes < 10
	mes="0"+str(mont(date()),1)
ELSE
	mes= str(mont(date()),2)
ENDIF
IF VAL(dia) < 10
	dia="0"+SUBSTR(dia,2,1)
ENDIF
hoy    = 'P'+anio+mes+dia
origu  = CURDIR()
origuen= 'Respaldar en:'+origu+'RESPALDO'
hoy1 = 'P'+anio+mes+dia
IF .not. FILE('respaldo/&hoy1..zip')
	desti='C'
	DO FORM f_respaldos
ENDIF
*************

DO G_MENU.MPR
READ EVENTS
CLEAR EVENTS
RETURN

PROCEDURE errhand
PARAMETER merror, mess, mess1, mprog, mlineno
do form f_error
QUIT

*****
* FUNCION COMPRUEBA CEDULA
FUNCTION cedula_si
PARAMETERS ced_aux
aa1 =VAL(SUBSTR(ced_aux,1,1))
aa2 =VAL(SUBSTR(ced_aux,2,1))
aa3 =VAL(SUBSTR(ced_aux,3,1))
aa4 =VAL(SUBSTR(ced_aux,4,1))
aa5 =VAL(SUBSTR(ced_aux,5,1))
aa6 =VAL(SUBSTR(ced_aux,6,1))
aa7 =VAL(SUBSTR(ced_aux,7,1))
aa8 =VAL(SUBSTR(ced_aux,8,1))
aa9 =VAL(SUBSTR(ced_aux,9,1))
aa10=VAL(SUBSTR(ced_aux,10,1))
bb1 = aa1*2
bb3 = aa3*2
bb5 = aa5*2
bb7 = aa7*2
bb9 = aa9*2
FOR I=1 TO 9 STEP 2
	ii=STR(i,1)
	IF bb&ii>9
		c = STR(bb&ii,2)
		c1 = VAL(SUBSTR(c,1,1))
		c2 = VAL(SUBSTR(c,2,1))
		bb&ii = c1 + c2
	ENDIF
NEXT i
val_ced = bb1+aa2+bb3+aa4+bb5+aa6+bb7+aa8+bb9
res_ced = 99

DO CASE
	CASE val_ced=>1 .and. val_ced<=10
		res_ced = 10 - val_ced
	CASE val_ced=>11.and. val_ced<=20
		res_ced = 20 - val_ced
	CASE val_ced=>21.and. val_ced<=30
		res_ced = 30 - val_ced
	CASE val_ced=>31.and. val_ced<=40
		res_ced = 40 - val_ced
	CASE val_ced=>41.and. val_ced<=50
		res_ced = 50 - val_ced
	CASE val_ced=>51.and. val_ced<=60
		res_ced = 60 - val_ced
	CASE val_ced=>61.and. val_ced<=70
		res_ced = 70 - val_ced
	CASE val_ced=>71.and. val_ced<=80
		res_ced = 80 - val_ced
	CASE val_ced=>81.and. val_ced<=90
		res_ced = 90 - val_ced
	OTHERWISE
		MESSAGEBOX('Comunicar a M.Sotomayor en error de cedula:'+TRANSFORM(val_ced),0)
ENDCASE
IF res_ced=aa10
	RETURN .t.
ELSE
	RETURN .f.
ENDIF
******
FUNCTION IsExeRunning(tcName, tlTerminate)
  LOCAL loLocator, loWMI, loProcesses, loProcess, llIsRunning
  loLocator = CREATEOBJECT('WBEMScripting.SWBEMLocator')
  loWMI = loLocator.ConnectServer()
  loWMI.Security_.ImpersonationLevel = 3  && Impersonate

  loProcesses = loWMI.ExecQuery([SELECT * FROM Win32_Process WHERE Name = '] + tcName + ['])
  llIsRunning = .F.
  IF loProcesses.COUNT > 1
    FOR EACH loProcess IN loProcesses
      llIsRunning = .T.
      IF tlTerminate
        loProcess.TERMINATE(0)
      ENDIF
    ENDFOR
  ENDIF
  RETURN llIsRunning
ENDFUNC
*******
***************************************
*Funcin : NtoL
*            Convierte un numero a letras, adaptado para moneda y decimales(centavos)
*Sintaxis:   =NtoL(pnum, pmnd, plet)
*Parametros:
*            pnum = Nmero a convertir (123.46)
*            pmnd = nombre de la moneda o producto ("dlares/dlar","euros/euro","copas/copa", etc...)
*            plet = manera literal de escribir (por defecto este ejemplo: 58=cincuenta y ocho)
*Ejemplos:
*            ? NtoL(351.21) = trescientos cincuenta y uno con veintiun centimos
*            ? NtoL(351.21,"pesetas/peseta") = trescientas cincuenta y una pesetas con veintiun centimos
*	     	 ? NtoL(1,"copas/copa") = una copa
*            ? NtoL(351.21,,1)= trescientos cincuentiuno con veintiun centavos
*Retorno:	El numero en caracter
*Creacin:	Marlon Sotomayor, Loja, Ecuador
*
FUNCTION NtoL
para pnum, pmnd, plet, it_dec_aux
priv knum, kmnd, klet, it_dec_aux
decl uni(20), dec(10), cie(10), mil(1), mll(1), bll(1)
priv letra, centimos, kint, kcnt, kmn1, kmn2, ksex
*--
it_dec_aux=iif(empt(it_dec_aux),2,it_dec_aux)
knum=iif(empt(pnum),0,pnum)
kmnd=iif(empt(pmnd),"",allt(pmnd))
klet=iif(empt(plet),"a y ","i")
kmn1=iif(at("/",allt(kmnd))=0,kmnd,left(kmnd,at("/",allt(kmnd))-1))
kmn2=right(kmnd,len(kmnd)-at("/",allt(kmnd)))
ksex=iif(right(kmn1,2)="as" or right(kmn2,1)="a",.f.,.t.)
*--
do case
 case knum=0
  letra=allt("cero"+" "+kmnd)
 othe
  l_uni1="uno       dos       tres      cuatro    cinco     seis      siete     ocho      nueve     diez      "
  l_uni2="once      doce      trece     catorce   quince    dieciseis diecisietedieciocho diecinueveveinte    "
  l_dec ="diez      veint     treint    cuarent   cincuent  sesent    setent    ochent    novent              "
  l_cie ="c         dosc      tresc     cuatroc   quin      seisc     setec     ochoc     novec               "
  *--
  for i=1 to 10
   uni(i)   =allt(subs(l_uni1,10*(i-1)+1,10))
   uni(i+10)=allt(subs(l_uni2,10*(i-1)+1,10))
   dec(i)   =allt(subs(l_dec ,10*(i-1)+1,10))
   cie(i)   =allt(subs(l_cie ,10*(i-1)+1,10))+"ient"+iif(i=1,"o",iif(ksex,"os","as"))
  endfor
  *--
  mil(1)  ="mil"
  mll(1)  ="millones"
  bll(1)  ="billones"
  *--
  kint    =int(knum)
  IF it_dec_aux=2
	  kcnt    =int((knum-int(knum))*100)
  ELSE
	  kcnt    =int((knum-int(knum))*1000)
  ENDIF
  *--
	letra   =allt(pntol(kint,iif(empt(pmnd),0,1))+" "+iif(kint=1,kmn2,kmn1))
*	centimos=iif(kcnt=0,"","con "+pntol(kcnt,1)+" dcima"+iif(kcnt=1,"","s"))
	IF kcnt<10
		centimos=iif(kcnt=0,"","coma cero "+pntol(kcnt,1)+iif(kcnt=1,"",""))
	ELSE
		centimos=iif(kcnt=0,"","coma "+pntol(kcnt,1)+iif(kcnt=1,"",""))
	ENDIF
ENDCASE
*--
RETURN letra+" "+centimos
*******************************************************************
FUNCTION pntol
para fnum,fm
local llet
*--
fnum=int(fnum)
*--
do case
 case fnum=0
  palabra=""
 case fnum=1
  palabra=iif(empt(fm),uni(1),"uno"+iif(ksex,"","a"))
 case betw(fnum,2,20)
  palabra=uni(fnum)
 case betw(fnum,21,99)
  llet=iif(betw(fnum,21,29),"i",klet)
  palabra=dec(fnum/10)
  palabra=palabra+iif(fnum-int(fnum/10)*10=0,"a",llet+pntol(fnum-int(fnum/10)*10,fm))
 case fnum=100
  palabra=left(cie(1),4)
 case betw(fnum,101,999)
  palabra=cie(fnum/100)+" "+pntol(fnum-int(fnum/100)*100,fm)
 case betw(fnum,1000,1999)
  palabra=mil(1)+" "+pntol(fnum-1000,fm)
 case betw(fnum,2000,999999)
  palabra=pntol(fnum/1000,1)+" "+mil(1)+" "+pntol(fnum-int(fnum/1000)*1000,fm)
 case betw(fnum,1000000,1999999)
  palabra="un "+left(mll(1),6)+" "+pntol(fnum-1000000,fm)
 case betw(fnum,2000000,999999999999)
  palabra=pntol(fnum/1000000,1)+" "+mll(1)+" "+pntol(fnum-int(fnum/1000000)*1000000,fm)
 case betw(fnum,1000000000000,1999999999999)
  palabra="un "+left(bll(1),6)+" "+pntol(fnum-1000000000000,fm)
 case betw(fnum,2000000000000,99999999999999999)
  palabra=pntol(fnum/1000000000000,1)+" "+bll(1)+" "+pntol(fnum-int(fnum/1000000000000)*1000000000000)
endcase
*--
retu allt(palabra)
************************************
DEFINE CLASS StatusBarControl AS OLECONTROL
	Visible = .T.
	Height = 25
ENDDEFINE
****************************************
*-*-*-* chequeo si hay internet o no
Function IsInterNetActive (tcURL) 
tcURL = IIF(TYPE("tcURL")="C" AND !EMPTY(tcURL),tcURL,"http://www.google.com") 
DECLARE INTEGER InternetCheckConnection in wininet; 
STRING lpszUrl,; 
INTEGER dwFlags,; 
INTEGER dwReserved 
RETURN ( InternetCheckConnection(tcURL, 1, 0) == 1) 
ENDFUNC 
